=== APKBUILD ===
# Maintainer: Akihito IRIE <akihito.irie@atmark-techno.com>

pkgname=armadillo-twin-agent
pkgver=1.9
pkgrel=0
_gitrev="$pkgver-r$pkgrel"
pkgdesc="agent software for accessing to Armadillo-Twin"
url="https://armadillo.atmark-techno.com/"
arch="all"
license="MIT AND Apache-2.0"
depends="device-info dbus se05x-tools"
makedepends="musl-dev linux-headers clang cmake samurai openssl-dev dbus-dev boost-dev"
source="armadillo-twin-agent-1.9-r0.tar.gz
aws-iot-device-sdk-cpp-v2_v1.32.1.tar.gz
AmazonRootCA1.pem"
subpackages="$pkgname-dbg"

builddir="$srcdir/$pkgname-$_gitrev"

_buildtype="RelWithDebInfo" # can be "Release", "RelWithDebInfo" or "Debug"

build() {
	cmake -B build -GNinja \
		-DAWS_IOT_DEVICE_SDK_CPP="$srcdir/aws-iot-device-sdk-cpp-v2" \
		-DCMAKE_BUILD_TYPE="$_buildtype" \
		-DBUILD_TESTS=ON \
		-DUSE_OPENSSL=ON \
		src
	ninja -C build
}

check() {
	ninja -C build test
}

package() {
	install -m755 -D build/armadillo-twin-agent \
			"$pkgdir/usr/sbin/$pkgname"
	install -m755 -D init.d/armadillo-twin-agentd \
			"$pkgdir/usr/libexec/${pkgname}d"
	install -m755 -D init.d/armadillo-twin-agentd.initd \
			"$pkgdir/etc/init.d/${pkgname}d"
	install -m755 -D scripts/reissue_url \
			"$pkgdir/usr/libexec/armadillo-twin/reissue_url"
	install -m755 -D scripts/is_lte_catm1_default \
			"$pkgdir/usr/libexec/armadillo-twin/is_lte_catm1_default"
	install -m644 -D config/agent.conf.example \
			"$pkgdir"/etc/atmark/armadillo-twin/agent.conf.example
	install -m644 -D "$srcdir/AmazonRootCA1.pem" \
			"$pkgdir"/usr/share/armadillo-twin-agent/AmazonRootCA1.pem
}

sha512sums="
e8878ae6fdcee743b5667ebcf7a1189105a6a2385b96c47d8f79ef8e1da5964cfb9f322b11bb76caa0b685d06f0a9eff133b2083f4e3daf6812669f0cb87ae55  armadillo-twin-agent-1.9-r0.tar.gz
d94bdd5c892b9603b762b75114f884658319537f29f52f87db14f5e149339137131d2fdfd059752013fc9bb391ce22d1e30e0d49387f5e69b7655348aa7d8a0e  aws-iot-device-sdk-cpp-v2_v1.32.1.tar.gz
64e62d0414e393915514adca96df74973c2b1ff37f0937248daef8d172420da1732bc3cca5c7e20e4f3218f26117b96f6bb1a6b3aaf8af18c29371aeed761791  AmazonRootCA1.pem
"
